/* 
 * File:     World.cpp
 * Author:   NMM
 * Date:     12.03.2006
 * Modified: 27.03.2006
 *
 * Purpose: Definitionen der Klasse World
 */
 
#include "World.h"

#define STARTING_SHEEP 100 


//Funktionen der Klasse Simulation

World::World(){
  int i;
  PaeSheep *this_sheep;
    
  /*
   * Construct the terrain
   */
  terr = new PaeTerrain();                       

  /* 
   * Add sheep to the sheep list
   */
   
  firstsheep = new PaeSheep(PaeRand(0,99),PaeRand(0,99),this);
  this_sheep = firstsheep;
  
  for(i=0;i<STARTING_SHEEP;i++){
      this_sheep->nextsheep = new PaeSheep(PaeRand(0,99),PaeRand(0,99),this);
      this_sheep = this_sheep->nextsheep;
  }
      
  sven = new PaeSheep;
  sven->SetPosition(50.0,50.0,1.0);
  sven->SetDirection(0.707,0.707,0.0);

  cout << "World created!" << endl;
}

void World::CreateSheep(){

    PaeSheep *this_sheep;
    float x = PaeRand(0,99);
    float y = PaeRand(0,99);      
    this_sheep = firstsheep;

    if(this_sheep == NULL){           //Falls es keine Schafe gibt erzeuge eines
       firstsheep = new PaeSheep(x,y,this);
       return;
    }
    
    while(this_sheep->nextsheep != NULL){ //suche das letzte Schaf der Liste
      this_sheep = this_sheep->nextsheep;
    }
    this_sheep->nextsheep = new PaeSheep(x,y,this); 
}





void World::Draw(){
  PaeSheep *this_sheep;
  int i;
  i=0;
  
  terr->Draw();
      
  this_sheep = firstsheep;
  while(this_sheep != NULL){       //sage jedem Schaf, dass es sich zeichnen soll
    i++;
    this_sheep->Draw();
    this_sheep = this_sheep->nextsheep;
  }
  
}









void World::Prepare(){
     PaeSheep *this_sheep;
     this_sheep = firstsheep;
     while(this_sheep != NULL){
       this_sheep->Think();
       this_sheep = this_sheep->nextsheep;
     }         
}

void World::Action(){
  PaeSheep *this_sheep;

  terr->GrowFood();

  this_sheep = firstsheep;
  while(this_sheep != NULL){
    this_sheep->Move();
    this_sheep = this_sheep->nextsheep;
  }         
}

float World::GetHeight(float x, float y){
      return 1; // terr->GetHeight(x,y);
}

   
